<?php
namespace Magenest\Salesforce\Controller\Adminhtml\Queue;

use Magenest\Salesforce\Model\Queue;

/**
 * Class Campaign
 * @package Magenest\Salesforce\Controller\Adminhtml\Queue
 */
class Campaign extends \Magenest\Salesforce\Controller\Adminhtml\Queue\AbstractionAction
{
    /** @var string */
    protected $type = Queue::TYPE_CAMPAIGN;

    /**
     * @return \Magento\Framework\App\ResponseInterface|void
     */
    public function execute()
    {
        if ($this->getRequest()->isAjax()) {
            $ruleCollection = $this->_ruleColFactory->create()->addFieldToSelect('rule_id');
            try {
                $ids = $this->getFilterDate($ruleCollection, 'from_date', 'to_date', $this->type)->getAllIds();
                $queueIds = $this->getQueueIdsByType($this->type);
                $this->_queueResource->deleteMultiQueues($queueIds);
                $this->publishData($ids, $this->type);
                $this->getResponse()->setBody($this->_json->serialize([
                    'error' => 0,
                    'message' => __('All Campaigns are being added to queue.'),
                ]));
                return;
            } catch (\Throwable $e) {
                $this->_logger->critical($e->getMessage());
                $this->getResponse()->setBody($this->_json->serialize([
                    'error' => 1,
                    'message' => __('Something went wrong while adding all records to queue. Error: ' . $e->getMessage())
                ]));
                return;
            }
        }
        return $this->_redirect('*/*/index');
    }
}
