<?php
namespace Magenest\Salesforce\Model\Sync;

class DataGetter
{
    /**
     * @var Job
     */
    protected $_job;

    /**
     * DataGetter constructor.
     * @param Job $job
     */
    public function __construct(
        Job $job
    ) {
        $this->_job = $job;
    }

    /**
     * Return an array of products on Salesforce
     *
     * @return mixed|string
     * @throws \Exception
     */
    public function getAllSalesforceProducts()
    {
        $query  = 'SELECT Id, ProductCode FROM Product2';
        return $this->_job->sendBatchRequest('query', 'Product2', $query);
    }

    /**
     * Return an array of pricebook entries on Salesforce
     *
     * @param string $pricebookId
     * @return mixed|string
     * @throws \Exception
     */
    public function getAllPricebookEntry($pricebookId)
    {
        $query  = "SELECT Id, ProductCode FROM PricebookEntry WHERE Pricebook2Id = '$pricebookId' ORDER BY Id";
        return $this->_job->sendBatchRequest('query', 'PricebookEntry', $query);
    }

    /**
     * Return an array of Opportunities on Salesforce
     *
     * @return mixed|string
     * @throws \Exception
     */
    public function getAllSalesforceOpportunities()
    {
        $query  = "SELECT Id, NAME FROM Opportunity";
        return $this->_job->sendBatchRequest('query', 'Opportunity', $query);
    }

    /**
     * Return an array of Campaigns on Salesforce
     *
     * @return mixed|string
     * @throws \Exception
     */
    public function getAllSalesforceCampaigns()
    {
        $query  = "SELECT Id, Name FROM Campaign";
        return $this->_job->sendBatchRequest('query', 'Campaign', $query);
    }
}
